# frozen_string_literal: true

module Hashtastic
  class DictionaryHasher
    class << self
      def call(dictionary, filter = [])
        encoded_message = Digester.call(dictionary, filter)

        hasher = Digest::SHA3.new(256)

        hasher.update(encoded_message)

        "0x#{hasher.hexdigest}"
      end

      private

      def extractor(dictionary, filter)
        dictionary.with_indifferent_access.slice(*filter)
      end
    end
  end
end
