# frozen_string_literal: true

module Hashtastic
  class DictionaryValuesHasher
    class << self
      def call(dictionary, values_at)
        values = extract_values(dictionary, values_at)

        ListHasher.call(values)
      end

      private

      def extract_values(hash, values_at)
        hash.with_indifferent_access.values_at(*values_at).compact
      end
    end
  end
end
