# frozen_string_literal: true

module Hashtastic
  class Digester
    class << self
      def call(dictionary, filter = [])
        dictionary = filter.empty? ? dictionary : extractor(dictionary, filter)

        URI.encode_www_form(dictionary.to_a.sort)
      end

      private

      def extractor(dictionary, filter)
        dictionary.with_indifferent_access.slice(*filter)
      end
    end
  end
end
