# frozen_string_literal: true

module Hashtastic
  class ListHasher
    def self.call(values, &block)
      hasher = Digest::SHA3.new(256)

      values.each do |value|
        value = block.call(value) if block

        hasher.update(value.to_s)
      end

      "0x#{hasher.hexdigest}"
    end
  end
end
